
from libcpp.memory cimport shared_ptr
from range cimport cpp_RangeBase

cdef extern from "ranges/ranges.h" namespace "CNORXZ":
    cdef cppclass cpp_RangeFactoryBase "CNORXZ::RangeFactoryBase":
        shared_ptr[cpp_RangeBase] create() except +

cdef extern from "ranges/ranges.h" namespace "CNORXZ":
    cdef cppclass cpp_CRangeFactory "CNORXZ::CRangeFactory" (cpp_RangeFactoryBase):
        cpp_CRangeFactory(size_t size) except +
        shared_ptr[cpp_RangeBase] create() except +
